﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ELTE.Basics.University
{
    class Program
    {
        static void Main(string[] args)
        {
            List<UniversityCitizen> citizens = new List<UniversityCitizen>();

            citizens.Add(new Student("Huba Hugó")); // polimorfizsmut használunk a lista feltöltésére
            citizens.Add(new Student("Sánta Rezső"));
            citizens.Add(new Teacher("Kis Ferenc"));
            Course c1 = (citizens[2] as Teacher).CreateCourse("Lazulás"); // típuskonverzió a műveletek használatához
            Course c2 = (citizens[2] as Teacher).CreateCourse("Pihizés");
            (citizens[0] as Student).SignForCourse(c1);
            (citizens[0] as Student).SignForCourse(c2);
            (citizens[1] as Student).SignForCourse(c2);

            Console.WriteLine("Egyetemi polgárok:");
            foreach (UniversityCitizen citizen in citizens)
            {
                Console.Write(citizen.Name + " (" + citizen.UniversityCode + ")");
                if (citizen is Teacher) // típusazonosítás
                    Console.WriteLine(", oktató");
                if (citizen is Student)
                    Console.WriteLine(", hallgató");
            }

            Console.WriteLine("Kurzusok:");
            foreach (String name in Course.ListedCourseNames) // statikus tulajdonság lekérdezése
            {
                Course course = Course.GetCourse(name); // statikus metódus meghívása
                Console.WriteLine(course.Name + ", létszám: " + course.StudentCount);
            }

            Console.ReadKey();
        }
    }
}
