﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ELTE.Basics.University
{
    class Teacher : UniversityCitizen // egyetemi tanár osztálya, az egyetemi polgár speciális esete
    {
        public Teacher(String name) : base(name) // ős konstruktorának meghívása
        { // egyéb tevékenység nem kell
        }

        public Course CreateCourse(String name)
        {
            Course c = new Course(this, name); // nyílt rekurzió használata az oktató objektum átadásával
            _Courses.Add(c);
            return c;
        }
        public Course GetCourse(String name) // kurzus lekérdezése név alapján
        {
            foreach (Course course in _Courses)
                if (course.Name == name) // ha sikerült megtalálnunk
                    return course; // akkor visszaadjuk
            return null; // különben nullát adunk vissza
        }

        public static List<String> ListedTeacherNames // statikus tulajdonság, a kurzusnevek lekérdezésére
        {
            get
            {
                List<String> courseNames = new List<String>();
                foreach (UniversityCitizen citizen in UniversityCitizen._ListOfCitizens) // lekérdezzük az ős statikus tagját
                    if (citizen is Teacher) // megnézzük, hogy tanár-e az objektum osztálya
                        courseNames.Add(citizen.Name); // létrehozunk egy új listát a kurzusokból
                return courseNames;
            }
        }

    }
}
