﻿using System;
using System.Collections.Generic;
using System.Text;

namespace ELTE.Basics.University
{
    abstract class UniversityCitizen // általános egyetemi polgár osztálya
    {
        // leszármazottban látható tulajdonságok
        protected String _Name;
        protected String _UniversityCode;
        protected List<Course> _Courses;

        public String Name { get { return _Name; } }
        public String UniversityCode { get { return _UniversityCode; } }

        public List<String> CourseNames // a kurzusok neveinek lekérdezése
        {
            get
            {
                List<String> courseNames = new List<String>();
                foreach (Course course in _Courses)
                    courseNames.Add(course.Name); // létrehozunk egy új listát a kurzusokból
                return courseNames;
            }
        }

        public UniversityCitizen(String name)
        {
            _Name = name;
            _UniversityCode = GenerateCode(name);
            _Courses = new List<Course>();

            _ListOfCitizens.Add(this); // aktuálisan mindig egy hallgató, vagy oktató példány lesz
        }


        // statikus tagok:
        protected static List<UniversityCitizen> _ListOfCitizens = new List<UniversityCitizen>();

        protected static String GenerateCode(String name) // kódgenerálás, amihez ismerni kell a többi polgár kódját is
        {
            String code = Char.ToUpper(name[0]) + Char.ToUpper(name[1]) + Char.ToUpper(name[name.IndexOf(' ') + 1]) + "PAAT.ELTE"; // kód generálása a név alapján
            Char modifierChar = 'A';
            foreach (Student s in _ListOfCitizens)
            {
                if (code == s._UniversityCode) // ha találtunk ugyanolyan nazonosítójú oktatót
                {
                    modifierChar++; // akkor módosítjuk az egyik karaktert
                    code = Char.ToUpper(name[0]) + Char.ToUpper(name[1]) + Char.ToUpper(name[name.IndexOf(' ') + 1]) + "PA" + modifierChar + "T.ELTE";
                }
            }
            return code;
        }
    }
}
